/*
 * Copyright (c) 2020 Reactor Energy
 * Mieszko Mazurek <mimaz@gmx.com>
 */

#pragma once

#include <reactor-types-gtype.h>
#include <rcom.h>

typedef enum { /*< flags >*/
    REACTOR_COM_STATUS_CHARGING = RCOM_STATUS_CHARGING,
    REACTOR_COM_STATUS_DISCHARGING = RCOM_STATUS_DISCHARGING,
    REACTOR_COM_STATUS_PROTECTED = RCOM_STATUS_PROTECTED,
    REACTOR_COM_STATUS_LOCKED = RCOM_STATUS_LOCKED,
} ReactorComStatus;

typedef enum { /*< flags >*/
    REACTOR_COM_PROTECTION_CELL_UV = RCOM_PROTECTION_CELL_UV,
    REACTOR_COM_PROTECTION_CELL_OV = RCOM_PROTECTION_CELL_OV,
    REACTOR_COM_PROTECTION_CHARGING_OT = RCOM_PROTECTION_CHARGING_OT,
    REACTOR_COM_PROTECTION_CHARGING_UT = RCOM_PROTECTION_CHARGING_UT,
    REACTOR_COM_PROTECTION_DISCHARGING_OT = RCOM_PROTECTION_DISCHARGING_OT,
    REACTOR_COM_PROTECTION_DISCHARGING_UT = RCOM_PROTECTION_DISCHARGING_UT,
    REACTOR_COM_PROTECTION_CHARGING_OC = RCOM_PROTECTION_CHARGING_OC,
    REACTOR_COM_PROTECTION_DISCHARGING_OC = RCOM_PROTECTION_DISCHARGING_OC,
} ReactorComProtection;

typedef enum { /*< flags >*/
    REACTOR_COM_QUERY_TIMESTAMP = RCOM_QUERY_TIMESTAMP,
    REACTOR_COM_QUERY_VOLTAGE = RCOM_QUERY_VOLTAGE,
    REACTOR_COM_QUERY_CURRENT = RCOM_QUERY_CURRENT,
    REACTOR_COM_QUERY_STATUS = RCOM_QUERY_STATUS,
    REACTOR_COM_QUERY_PROTECTION = RCOM_QUERY_PROTECTION,
    REACTOR_COM_QUERY_BALANCING = RCOM_QUERY_BALANCING,
    REACTOR_COM_QUERY_TEMPERATURE = RCOM_QUERY_TEMPERATURE,
    REACTOR_COM_QUERY_CONFIG = RCOM_QUERY_CONFIG,
    REACTOR_COM_QUERY_CAPLIMIT = RCOM_QUERY_CAPLIMIT,
} ReactorComQuery;

typedef enum {
    REACTOR_COM_BQ769X0_WRITE = RCOM_BQ769X0_WRITE,
    REACTOR_COM_BQ769X0_READ = RCOM_BQ769X0_READ,
    REACTOR_COM_BQ769X0_DATA = RCOM_BQ769X0_DATA,
} ReactorComBq769x0;
